//## begin module%1.4%.codegen_version preserve=yes
//   Read the documentation to learn more about C++ code generator
//   versioning.
//## end module%1.4%.codegen_version

//## begin module%4AB7B9D103D0.cm preserve=no
//	  %X% %Q% %Z% %W%
//## end module%4AB7B9D103D0.cm

//## begin module%4AB7B9D103D0.cp preserve=no
//## end module%4AB7B9D103D0.cp

//## Module: PlotGroupCreatorClasses%4AB7B9D103D0; Package specification
//## Subsystem: XSPlot::Plot%3D625E94026B
//## Source file: /local/data/xerxes1/gordon/headas/Xspec/src/XSPlot/Plot/PlotGroupCreatorClasses.h

#ifndef PLOTGROUPCREATORCLASSES_H
#define PLOTGROUPCREATORCLASSES_H 1

//## begin module%4AB7B9D103D0.additionalIncludes preserve=no
//## end module%4AB7B9D103D0.additionalIncludes

//## begin module%4AB7B9D103D0.includes preserve=yes
#include <xsTypes.h>
//## end module%4AB7B9D103D0.includes

// PlotGroupCreator
#include <XSPlot/Plot/PlotGroupCreator.h>
//## begin module%4AB7B9D103D0.declarations preserve=no
//## end module%4AB7B9D103D0.declarations

//## begin module%4AB7B9D103D0.additionalDeclarations preserve=yes

class Model;
//## end module%4AB7B9D103D0.additionalDeclarations


//## begin CreateModelPlotGroups%4AB7CEF5026D.preface preserve=yes
//## end CreateModelPlotGroups%4AB7CEF5026D.preface

//## Class: CreateModelPlotGroups%4AB7CEF5026D
//## Category: XSPlot::Plot%3D625E6A0065
//## Subsystem: XSPlot::Plot%3D625E94026B
//## Persistence: Transient
//## Cardinality/Multiplicity: n



class CreateModelPlotGroups : public PlotGroupCreator  //## Inherits: <unnamed>%4AB7CF0D021E
{
  //## begin CreateModelPlotGroups%4AB7CEF5026D.initialDeclarations preserve=yes
  //## end CreateModelPlotGroups%4AB7CEF5026D.initialDeclarations

  public:
    //## Constructors (generated)
      CreateModelPlotGroups();

    //## Destructor (generated)
      virtual ~CreateModelPlotGroups();


    //## Other Operations (specified)
      //## Operation: createPlotGroups%4AB7CFBB0297
      virtual std::vector<PlotGroup*> createPlotGroups (const PlotSettings& settings);

    //## Get and Set Operations for Class Attributes (generated)

      //## Attribute: modName%4AC37DE003C7
      const string& modName () const;
      void modName (const string& value);

    // Additional Public Declarations
      //## begin CreateModelPlotGroups%4AB7CEF5026D.public preserve=yes
      //## end CreateModelPlotGroups%4AB7CEF5026D.public

  protected:
    // Additional Protected Declarations
      //## begin CreateModelPlotGroups%4AB7CEF5026D.protected preserve=yes
      //## end CreateModelPlotGroups%4AB7CEF5026D.protected

  private:
    //## Constructors (generated)
      CreateModelPlotGroups(const CreateModelPlotGroups &right);

    //## Assignment Operation (generated)
      CreateModelPlotGroups & operator=(const CreateModelPlotGroups &right);


    //## Other Operations (specified)
      //## Operation: initializePlotGroup%4AC37F220091
      PlotGroup* initializePlotGroup (const Model* model, int specNum, const RealArray& energy, const PlotSettings& settings);

    // Additional Private Declarations
      //## begin CreateModelPlotGroups%4AB7CEF5026D.private preserve=yes
      //## end CreateModelPlotGroups%4AB7CEF5026D.private

  private: //## implementation
    // Data Members for Class Attributes

      //## begin CreateModelPlotGroups::modName%4AC37DE003C7.attr preserve=no  public: string {U} 
      string m_modName;
      //## end CreateModelPlotGroups::modName%4AC37DE003C7.attr

    // Additional Implementation Declarations
      //## begin CreateModelPlotGroups%4AB7CEF5026D.implementation preserve=yes
      //## end CreateModelPlotGroups%4AB7CEF5026D.implementation

};

//## begin CreateModelPlotGroups%4AB7CEF5026D.postscript preserve=yes
//## end CreateModelPlotGroups%4AB7CEF5026D.postscript

//## begin CreateDemPlotGroups%4AB7D061021C.preface preserve=yes
//## end CreateDemPlotGroups%4AB7D061021C.preface

//## Class: CreateDemPlotGroups%4AB7D061021C
//## Category: XSPlot::Plot%3D625E6A0065
//## Subsystem: XSPlot::Plot%3D625E94026B
//## Persistence: Transient
//## Cardinality/Multiplicity: n



class CreateDemPlotGroups : public PlotGroupCreator  //## Inherits: <unnamed>%4AB7D08F031F
{
  //## begin CreateDemPlotGroups%4AB7D061021C.initialDeclarations preserve=yes
  //## end CreateDemPlotGroups%4AB7D061021C.initialDeclarations

  public:
    //## Constructors (generated)
      CreateDemPlotGroups();

    //## Destructor (generated)
      virtual ~CreateDemPlotGroups();


    //## Other Operations (specified)
      //## Operation: createPlotGroups%4AC38929013E
      virtual std::vector<PlotGroup*> createPlotGroups (const PlotSettings& settings);

    // Additional Public Declarations
      //## begin CreateDemPlotGroups%4AB7D061021C.public preserve=yes
      //## end CreateDemPlotGroups%4AB7D061021C.public

  protected:
    // Additional Protected Declarations
      //## begin CreateDemPlotGroups%4AB7D061021C.protected preserve=yes
      //## end CreateDemPlotGroups%4AB7D061021C.protected

  private:
    //## Constructors (generated)
      CreateDemPlotGroups(const CreateDemPlotGroups &right);

    //## Assignment Operation (generated)
      CreateDemPlotGroups & operator=(const CreateDemPlotGroups &right);

    // Additional Private Declarations
      //## begin CreateDemPlotGroups%4AB7D061021C.private preserve=yes
      //## end CreateDemPlotGroups%4AB7D061021C.private

  private: //## implementation
    // Additional Implementation Declarations
      //## begin CreateDemPlotGroups%4AB7D061021C.implementation preserve=yes
      //## end CreateDemPlotGroups%4AB7D061021C.implementation

};

//## begin CreateDemPlotGroups%4AB7D061021C.postscript preserve=yes
//## end CreateDemPlotGroups%4AB7D061021C.postscript

//## begin CreateEfficiencyPlotGroups%4AB7D19801AD.preface preserve=yes
//## end CreateEfficiencyPlotGroups%4AB7D19801AD.preface

//## Class: CreateEfficiencyPlotGroups%4AB7D19801AD
//## Category: XSPlot::Plot%3D625E6A0065
//## Subsystem: XSPlot::Plot%3D625E94026B
//## Persistence: Transient
//## Cardinality/Multiplicity: n



class CreateEfficiencyPlotGroups : public PlotGroupCreator  //## Inherits: <unnamed>%4AB7D1B6024C
{
  //## begin CreateEfficiencyPlotGroups%4AB7D19801AD.initialDeclarations preserve=yes
  //## end CreateEfficiencyPlotGroups%4AB7D19801AD.initialDeclarations

  public:
    //## Constructors (generated)
      CreateEfficiencyPlotGroups();

    //## Destructor (generated)
      virtual ~CreateEfficiencyPlotGroups();


    //## Other Operations (specified)
      //## Operation: createPlotGroups%4AC3894701CF
      virtual std::vector<PlotGroup*> createPlotGroups (const PlotSettings& settings);

    // Additional Public Declarations
      //## begin CreateEfficiencyPlotGroups%4AB7D19801AD.public preserve=yes
      //## end CreateEfficiencyPlotGroups%4AB7D19801AD.public

  protected:
    // Additional Protected Declarations
      //## begin CreateEfficiencyPlotGroups%4AB7D19801AD.protected preserve=yes
      //## end CreateEfficiencyPlotGroups%4AB7D19801AD.protected

  private:
    //## Constructors (generated)
      CreateEfficiencyPlotGroups(const CreateEfficiencyPlotGroups &right);

    //## Assignment Operation (generated)
      CreateEfficiencyPlotGroups & operator=(const CreateEfficiencyPlotGroups &right);

    // Additional Private Declarations
      //## begin CreateEfficiencyPlotGroups%4AB7D19801AD.private preserve=yes
      //## end CreateEfficiencyPlotGroups%4AB7D19801AD.private

  private: //## implementation
    // Additional Implementation Declarations
      //## begin CreateEfficiencyPlotGroups%4AB7D19801AD.implementation preserve=yes
      //## end CreateEfficiencyPlotGroups%4AB7D19801AD.implementation

};

//## begin CreateEfficiencyPlotGroups%4AB7D19801AD.postscript preserve=yes
//## end CreateEfficiencyPlotGroups%4AB7D19801AD.postscript

//## begin CreateChainPlotGroups%4AB7D2610026.preface preserve=yes
//## end CreateChainPlotGroups%4AB7D2610026.preface

//## Class: CreateChainPlotGroups%4AB7D2610026
//## Category: XSPlot::Plot%3D625E6A0065
//## Subsystem: XSPlot::Plot%3D625E94026B
//## Persistence: Transient
//## Cardinality/Multiplicity: n



class CreateChainPlotGroups : public PlotGroupCreator  //## Inherits: <unnamed>%4AB7D2A6004D
{
  //## begin CreateChainPlotGroups%4AB7D2610026.initialDeclarations preserve=yes
  //## end CreateChainPlotGroups%4AB7D2610026.initialDeclarations

  public:
    //## Constructors (generated)
      CreateChainPlotGroups();

    //## Destructor (generated)
      virtual ~CreateChainPlotGroups();


    //## Other Operations (specified)
      //## Operation: createPlotGroups%4AC3890B0259
      virtual std::vector<PlotGroup*> createPlotGroups (const PlotSettings& settings);

    //## Get and Set Operations for Class Attributes (generated)

      //## Attribute: xColNum%4AC513290045
      size_t xColNum () const;
      void xColNum (size_t value);

      //## Attribute: yColNum%4AC513630084
      size_t yColNum () const;
      void yColNum (size_t value);

    // Additional Public Declarations
      //## begin CreateChainPlotGroups%4AB7D2610026.public preserve=yes
      //## end CreateChainPlotGroups%4AB7D2610026.public

  protected:
    // Additional Protected Declarations
      //## begin CreateChainPlotGroups%4AB7D2610026.protected preserve=yes
      //## end CreateChainPlotGroups%4AB7D2610026.protected

  private:
    //## Constructors (generated)
      CreateChainPlotGroups(const CreateChainPlotGroups &right);

    //## Assignment Operation (generated)
      CreateChainPlotGroups & operator=(const CreateChainPlotGroups &right);

    // Additional Private Declarations
      //## begin CreateChainPlotGroups%4AB7D2610026.private preserve=yes
      //## end CreateChainPlotGroups%4AB7D2610026.private

  private: //## implementation
    // Data Members for Class Attributes

      //## begin CreateChainPlotGroups::xColNum%4AC513290045.attr preserve=no  public: size_t {U} 
      size_t m_xColNum;
      //## end CreateChainPlotGroups::xColNum%4AC513290045.attr

      //## begin CreateChainPlotGroups::yColNum%4AC513630084.attr preserve=no  public: size_t {U} 
      size_t m_yColNum;
      //## end CreateChainPlotGroups::yColNum%4AC513630084.attr

    // Additional Implementation Declarations
      //## begin CreateChainPlotGroups%4AB7D2610026.implementation preserve=yes
      //## end CreateChainPlotGroups%4AB7D2610026.implementation

};

//## begin CreateChainPlotGroups%4AB7D2610026.postscript preserve=yes
//## end CreateChainPlotGroups%4AB7D2610026.postscript

// Class CreateModelPlotGroups 

//## Get and Set Operations for Class Attributes (inline)

inline const string& CreateModelPlotGroups::modName () const
{
  //## begin CreateModelPlotGroups::modName%4AC37DE003C7.get preserve=no
  return m_modName;
  //## end CreateModelPlotGroups::modName%4AC37DE003C7.get
}

inline void CreateModelPlotGroups::modName (const string& value)
{
  //## begin CreateModelPlotGroups::modName%4AC37DE003C7.set preserve=no
  m_modName = value;
  //## end CreateModelPlotGroups::modName%4AC37DE003C7.set
}

// Class CreateDemPlotGroups 

// Class CreateEfficiencyPlotGroups 

// Class CreateChainPlotGroups 

//## Get and Set Operations for Class Attributes (inline)

inline size_t CreateChainPlotGroups::xColNum () const
{
  //## begin CreateChainPlotGroups::xColNum%4AC513290045.get preserve=no
  return m_xColNum;
  //## end CreateChainPlotGroups::xColNum%4AC513290045.get
}

inline void CreateChainPlotGroups::xColNum (size_t value)
{
  //## begin CreateChainPlotGroups::xColNum%4AC513290045.set preserve=no
  m_xColNum = value;
  //## end CreateChainPlotGroups::xColNum%4AC513290045.set
}

inline size_t CreateChainPlotGroups::yColNum () const
{
  //## begin CreateChainPlotGroups::yColNum%4AC513630084.get preserve=no
  return m_yColNum;
  //## end CreateChainPlotGroups::yColNum%4AC513630084.get
}

inline void CreateChainPlotGroups::yColNum (size_t value)
{
  //## begin CreateChainPlotGroups::yColNum%4AC513630084.set preserve=no
  m_yColNum = value;
  //## end CreateChainPlotGroups::yColNum%4AC513630084.set
}

//## begin module%4AB7B9D103D0.epilog preserve=yes
//## end module%4AB7B9D103D0.epilog


#endif
